/*********************************************************************
 *       This file is part of the Mandala library source code.       *
 *                   Copyright (C) 2002                              *
 *                                                                   *
 *       Authors : eipi - eipiequalsnoone@users.sf.net               *
 *                                                                   *
 * This library is free software; you can redistribute it and/or     *
 * modify it under the terms of the GNU Lesser General Public        *
 * License as published by the Free Software Foundation; either      *
 * version 2.1 of the License, or (at your option) any later version.*
 *                                                                   *
 * This library is distributed in the hope that it will be useful,   *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *
 * Lesser General Public License for more details.                   *
 *                                                                   *
 * You should have received a copy of the GNU Lesser General Public  *
 * License along with this library; if not, write to                 *
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,   *
 * Boston, MA  02111-1307  USA                                       *
 *********************************************************************/
package helloWorld;

import mandala.jacob.*;
import mandala.rami.*;

public class RSOR_HelloWorld implements java.io.Serializable {
    public static void main(String[] args) {
        if (args.length != 1) {
            System.err.println("Usage : " + 
                               RSOR_HelloWorld.class.getName() + 
                               " RemoteActiveMapAddress\n");
            System.exit(1);
        }
                
        // gets a proxy on a remote active map
        ActiveMap activeMap = null;
        try{
            activeMap = (mandala.jacob.remote.RemoteActiveMap) 
                new javax.naming.InitialContext().lookup(args[0]);
        }catch(Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
        
        Framework.setFactory(new SORFactory(activeMap));
        
        jaya.helloWorld.HelloWorld rsor_helloWorld = 
            new jaya.helloWorld.HelloWorld();
        
        FutureClient future = rsor_helloWorld.rami_toString();
        
        try{
            System.out.println(future.waitForResult());
        }catch(Throwable t) {
            t.printStackTrace();
            System.exit(1);
        }
        

        // Removing the stored object from the remote hashmap and invokes its
        // 'toString()' method.
        StoredObjectReference rsor = 
            (StoredObjectReference) rsor_helloWorld.getAsynchronousReference();
        
        HelloWorld object = (HelloWorld) rsor.remove();
        
        System.out.println(object);
    }
}
