package pi;

import mandala.rami.*;
import mandala.jacob.*;

public class RSOR_PiComputer implements java.io.Serializable {
    public static void main(String[] args) {
        if (args.length != 3) {
            System.err.println(PiComputer.usage(RSOR_PiComputer.class, 
                                                "RemoteActiveMapAddress"));
            System.exit(1);
        }
                
        long startChrono = System.currentTimeMillis();

        IntInterval interval = new IntInterval(0,
                                               Integer.parseInt(args[0]));
                
        // gets a proxy on a remote active map
        ActiveMap activeMap = null;
        try{
            activeMap = (mandala.jacob.remote.RemoteActiveMap)
                new javax.naming.InitialContext().lookup(args[2]);
        }catch(Exception e) {
            e.printStackTrace();
            System.exit(1);
        }

        // Constructs the factory which generates RSOR(computer)
        
        // Then this factory generates RSOR()
        Framework.setFactory(new SORFactory(activeMap));
        jaya.pi.PiComputer computer = new jaya.pi.PiComputer(interval.end);
        
        StoredObjectReference sor = 
            (StoredObjectReference) computer.getAsynchronousReference();
        mandala.rami.impl.BenchmarkerCallback benchmarker = 
            new mandala.rami.impl.BenchmarkerCallback();
        mandala.rami.impl.CallbackList callbackList = 
            new mandala.rami.impl.CallbackList();
        callbackList.addCallback(benchmarker);
        callbackList.addCallback(new CleanerCallback());
        sor.getCallbackManager().setGlobalCallback(callbackList);
        
        long callStart = System.currentTimeMillis();
        
        benchmarker.startBenchmark(callStart);
        
        PiComputer.Result result = null;
        try{
            result = (PiComputer.Result)
                computer.rami_compute(interval, args[1]).waitForResult();
        }catch(Throwable t) {
            t.printStackTrace();
            System.exit(1);
        }
        
        PiComputer.logResult(interval,
                             1,
                             result,
                             System.currentTimeMillis() - startChrono);
    }
}
   
        
