package pi;

import mandala.rami.*;
import mandala.jacob.*;
import mandala.util.*;

public class SOR_PiComputer implements java.io.Serializable {
    public static Syslog syslog = PiComputer.syslog;

    public static void main(String[] args) {
        if (args.length != 2) {
            syslog.error(PiComputer.usage(SOR_PiComputer.class));
            System.exit(1);
        }
        
        long startChrono = System.currentTimeMillis();
        
        IntInterval interval = new IntInterval(0,
                                               Integer.parseInt(args[0]));
        
        mandala.rami.impl.AsynchronousPolicy policy = 
            new mandala.rami.impl.ThreadPooledPolicy();
        
        ActiveMap activeMap = new mandala.jacob.impl.ActiveMapImpl(policy);
        
        Framework.setFactory(new SORFactory(activeMap));
        
        jaya.pi.PiComputer computer = new jaya.pi.PiComputer(interval.end);
        
        mandala.jacob.StoredObjectReference sor = 
            (mandala.jacob.StoredObjectReference) 
            computer.getAsynchronousReference();

        mandala.rami.impl.BenchmarkerCallback benchmarker = 
            new mandala.rami.impl.BenchmarkerCallback();
        
        sor.getCallbackManager().setGlobalCallback(benchmarker);
        
        benchmarker.startBenchmark();
        PiComputer.Result result = null;
        try{
            result = (PiComputer.Result)
                computer.rami_compute(interval, args[1]).waitForResult();
        }catch(Throwable t) {
            t.printStackTrace();
            System.exit(1);
        }
        
        PiComputer.logResult(interval,
                             1,
                             result,
                             System.currentTimeMillis() - startChrono);
        
        sor.remove();
    }
}   
